<?php 

// DOCUMENT: Listet alle Spalten auf
// AUTHOR: M.Beranek <marcus@beranek.de>
// DATE: DD.MM.YYYY
// COPYRIGHT: M.Beranek


// TODO: Type-Detection

// Fehlermeldungen abschalten:
error_reporting(0);

// Bentigte Includes laden:
if( ! defined("DB_FUNCTIONS_COLUMN") )
	include( "./includes/db_functions_column.php" );

//if( ! defined("GENERIC_TRACER_CLASS") )
//	include( "./Tracer/generic_tracer.class.php" );
//
//$tracer = new Tracer("/tmp/trace.log");
//$tracer->setTracingActive( false );

// bergebene Parameter:
$databaseHost  = $_POST[ "dbhost" ];
$databaseUser  = $_POST[ "dbuser" ];
$databasePass  = $_POST[ "dbpass" ];
$database      = $_POST[ "db" ];
$databaseTable = $_POST[ "dbtable" ];
$prefixCheck   = (int) $_POST[ "prefixcheck" ];

// Wenn keine Werte via POST gesetzt wurden, akzeptieren wir auch GET-Werte:
if( empty($databaseHost) )  $databaseHost  = $_GET[ "dbhost" ];
if( empty($databaseUser) )  $databaseUser  = $_GET[ "dbuser" ];
if( empty($databasePass) )  $databasePass  = $_GET[ "dbpass" ];
if( empty($database) )      $database      = $_GET[ "db" ];
if( empty($databaseTable) ) $databaseTable = $_GET[ "dbtable" ];
if( $prefixCheck == 0 )     $prefixCheck   = (int) $_GET[ "prefixcheck" ];

// Parameter fr Back-Link
$backParams = "dbhost=".urlencode( $databaseHost )
	."&amp;dbuser=".urlencode( $databaseUser )
	."&amp;dbpass=".urlencode( $databasePass )
	."&amp;db=".urlencode( $database )
	."&amp;dbtable=".urlencode( $databaseTable );

// Parameter fr Back-URL
$backParamsURL = "dbhost=".urlencode( $databaseHost )
	."&dbuser=".urlencode( $databaseUser )
	."&dbpass=".urlencode( $databasePass )
	."&db=".urlencode( $database )
	."&dbtable=".urlencode( $databaseTable );

// Parameter fr die hidden-Felder fr den Prefix-Check:
$paramsPrefixcheck = "<input type='hidden' name='dbhost' value=\"".htmlentities( $databaseHost )."\">"
	."<input type='hidden' name='dbuser' value=\"".htmlentities( $databaseUser )."\">"
	."<input type='hidden' name='dbpass' value=\"".htmlentities( $databasePass )."\">"
	."<input type='hidden' name='db' value=\"".htmlentities( $database )."\">"
	."<input type='hidden' name='dbtable' value=\"".htmlentities( $databaseTable )."\">"
	."<input type='hidden' name='prefixcheck' value='1'>";

// Parameter fr die hidden-Felder fr den Prefix-Check:
$paramsNoPrefixcheck = "<input type='hidden' name='dbhost' value=\"".htmlentities( $databaseHost )."\">"
	."<input type='hidden' name='dbuser' value=\"".htmlentities( $databaseUser )."\">"
	."<input type='hidden' name='dbpass' value=\"".htmlentities( $databasePass )."\">"
	."<input type='hidden' name='db' value=\"".htmlentities( $database )."\">"
	."<input type='hidden' name='dbtable' value=\"".htmlentities( $databaseTable )."\">"
	."<input type='hidden' name='prefixcheck' value='0'>";


// Soll nach einem Prefix gesucht werden? 
$doPrefixSearch = ($prefixCheck > 0);


// Primary-Key
$primaryKey = "";


// Zunchst eine Verbindung zu MySQL aufbauen:
mysql_connect( $databaseHost, $databaseUser, $databasePass );

// Fehler abfangen:
if( mysql_errno() )
{
	/*
	echo "<div class='error'>".htmlentities(mysql_error() )."</div>";
	exit();
	*/
	$backLink = "./db.php?$backParamsURL";
	Header( "Status: 307" );
	Header( "Location: error.php?back=".urlencode($backLink)."&err=".urlencode( mysql_error() ) );
	exit;
}


// Dann die Datenbank auswhlen:
mysql_select_db( $database );

// Fehler abfangen:
if( mysql_errno() )
{
	/*
	echo "<div class='error'>".htmlentities(mysql_error() )."</div>";
	exit();
	*/
	$backLink = "./db.php?$backParamsURL";
	Header( "Status: 307" );
	Header( "Location: error.php?back=".urlencode($backLink)."&err=".urlencode( mysql_error() ) );
	exit;
}


// Dann die Spalten der Tabelle auslesen:
$colListResource = mysql_query( "SHOW COLUMNS FROM ".addslashes($databaseTable) );

// Fehler abfangen:
if( mysql_errno() )
{
	/*
	echo "<div class='error'>".htmlentities(mysql_error() )."</div>";
	exit();
	*/
	$backLink = "./db.php?$backParamsURL";
	Header( "Status: 307" );
	Header( "Location: error.php?back=".urlencode($backLink)."&err=".urlencode( mysql_error() ) );
	exit;
}


// Buffer fr das Prefix:
$colPrefix = "";

// Prefix-Lnge:
$colPrefixLength = 0;

if( $doPrefixSearch )
{
	// Feststellen, ob ein Prefix vorhanden ist:
	// Wenn ein Prefix vorhanden ist, dann sollte es in 
	// _allen_ Spalten vorkommen. Ansonsten knnten wir nur
	// raten...
	
	// Buffer fr den letzten Spaltennamen:
	$prevColumn = "";
	
	// Zunchst ist das Prefix leer. Da das Prefix (falls vorhanden) am
	// Anfang aller Spalten-Namen steht, wird es beim ersten Durchlauf 
	// auf den Wert des Names der ersten Spalte gesetzt. Anschlieend
	// werden bei jedem weiteren Vergleich alle die Buchstaben 
	// weggestrichen, die nicht in Prefix und Spalten-Name vorhanden 
	// sind. 
	// Vergleichsrichtung:
	$colPrefixInitialized = false;
	
	// Falls des Prefix leer ist, aber noch nicht alle Namen abgearbeitet 
	// sind, knnen wir getrost abbrechen, da das Prefix ja in allen Namen
	// vorhanden sein mu!
	$stop = false;
	
	$columnCounter = 0;
	
	while( ( $colEntry = mysql_fetch_row( $colListResource ) ) && ( ! $stop ) )
	{
		// Mit zhlen:
		$columnCounter++;
		
		// Datanbankname
		$column = $colEntry[0];
		//$tracer->trace( "col: $column" );
		
		if( $colPrefixInitialized ) {
			
			//$tracer->trace( "prefix initialized: $colPrefix." );
			
			
			// Prefix mit Spaltennamen vergleichen. 
			
			// Ist der Spaltenname krzer als unser aktuelles Prefix
			// ist das Prefix zu lang!
			$colLength = strlen( $column );
			if( $colLength < $colPrefixLength ){
				$colPrefix = substr( $colPrefix, 0, $colLength-1);
				$colPrefixLength = $colLength;
				//$tracer->trace( "diff: col - prefix." );
				//$tracer->trace( "prefix now: $colPrefix." );
			}
			
			// Wir beginnen mit dem letzten Buchstaben des Prefix.
			// Achtung: Zhlung beginnt bei 0!
			$posIndex = $colPrefixLength-1;
			//$tracer->trace( "starting at position: $posIndex (prefix-length: $colPrefixLength)." );
			
			$prefixFound = false;
			while( ! $prefixFound )
			{
				// Solange die Buchstaben unterschiedlich sind, eine
				// Position nach links gehen:
				//$tracer->trace( "checking column-name position: $posIndex" );
				while( ($column[$posIndex] != $colPrefix[$posIndex]) && ($posIndex>0)  )
				{
					//$tracer->trace( "no identity." );
					$posIndex--;
				}
				
				//$tracer->trace( "identity at position $posIndex." );
				
				// Falls ein passender Buchstabe gefunden wurde: 
				if( $posIndex > 0 )
				{
					// Abschneiden der berflssigen Buchstaben:
					$colPrefix = substr( $colPrefix, 0, $posIndex +1 );
					$colPrefixLength = $posIndex +1;
					
					//$tracer->trace( "prefix now: $colPrefix" );
					
					// Abschneiden der berflssigen Buchstaben:
					$columnBeginning = substr( $column, 0, $posIndex +1 );
					
					// Falls es sich um ein echtes Prefix handelt, mssen 
					// Prefix und Spaltenbeginn bereinstimmen:
					if( $columnBeginning == $colPrefix )
					{
						// Abbruch fr diese Spalte.
						$prefixFound = true;
						//$tracer->trace( "prefix matches column: prefix found." );
					} /* end-if( colBeginn == prefix  ) */
					else
					{
						//$tracer->trace( "prefix does not matches column: prefix not found." );
						// Falls Spaltenbeginn und Prefix nicht identisch sind,
						// knnen wir um eine Stelle weiterrcken.
						// Da aber die Nichtbereinstimmung im vorderen Teil des
						// Prefixes vorhanden sein mu (da die Abbruchbedingung 
						// der innene while-Schleife die Gleichheit des letzten 
						// Buchstabens im Prefix mit dem Spaltennamen fordert),
						// knnen wir soger zwei Schritte weiterrcken!
						// 
						// Beispiel:
						// spalte-1: col_name
						// => prefix = col_name
						// spalte-2: col_hausnummer
						// => prefix = col_na   (bereinstimmung bei "a"!)
						// Dennoch ist "col_na" kein Prefix, da 
						// "col_na" != "col_ha" 
						// Da aber der 6. Buchstabe ("a") in beiden identisch ist, 
						// mu eine weitere Nicht-bereinstimmung in den Buchstaben
						// 1 bis 5 liegen. demnach kann auch "col_n" kein Prefix sein.
						// Folglich knnen wir direkt den Wert "col_" berprfen.
						$posIndex--;
						$posIndex--;
						//$tracer->trace( "position now: $posIndex." );
					} /* end-else( columnBeginning == colPrefix  )  */
					
				} /* end-if( pos>0 ) */
				else
				{
					// Abbruch bei Position 0!
					$colPrefix = "";
					$colPrefixLength = 0;
					$prefixFound = true;
					$stop = true;
					//$tracer->trace( "position 0 reached, no prefix possible. stopping." );
				} /* end-else( pos>0 ) */
			}  /* end-while( ! prefixFound ) */
		}  /* end-if( colPrefixInitialized ) */
		else
		{
			// Prefix den ersten Spaltennamen zuweisen:
			$colPrefix = $column;
			$colPrefixInitialized = true;
			$colPrefixLength = strlen($colPrefix);
			//$tracer->trace( "initializing prefix to: $colPrefix, length: $colPrefixLength." );
			
		} /* end-else colPrefixInitialized */
		
	}
	
	
	// Bei nur einer Spalte (kann ja theoretisch auch vorkommen)
	// Schmeien wir das Prefix weg. das wre ja identisch mit dem
	// ersten (und einzigen) Spaltennamen.
	if( $columnCounter == 1 ) $colPrefix = "";
	
	// Datanbank-Cursor zurcksetzen:
	mysql_data_seek( $colListResource, 0 );
	
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" 
	"http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
	<title></title>
	<link type="text/css" href="./styles/default.css" rel="stylesheet">
	</head>
	<body>
	<div id="navitop"><div class='navicontent'><a href="./table.php?<?php echo $backParams; ?>">Back</a></div></div>
	<div id="content">
	<h1><?php echo htmlentities($databaseUser); ?>@<?php echo htmlentities($databaseHost); ?>: <?php echo htmlentities($database); ?>.<?php echo htmlentities($databaseTable); ?>.columns</h1>
	<div id="info">
	Getter: function to get the column-data<br>
	Setter: function to set the columns-data<br>
	set on insert: sets the columns-data when inserting a new dataset<br>
	set on update: sets the columns-data when updating an already loaded dataset<br>
	<!-- load on demand only: loads the data, when &quot;Getter&quot; is called<br> -->
	</div>
<?php 

// Zhlvariable:
$positionCounter = 0;

if( $doPrefixSearch )
{
?>
	<div class='head'> 
	<?php 
	if( $colPrefixLength > 0 )
	{
	?>
	<form action="<?php echo $_SERVER['PHP_SELF']; ?>">
		<?php echo $paramsNoPrefixcheck; ?>
		<input type="submit" name="pcheck" value="Show prefix in getter/setter">
	</form>&nbsp;
		Prefix found: &quot;<?php echo htmlentities($colPrefix); ?>&quot;.
	<?php 
	}
	else
	{
		echo "No prefix found.";
	}
	?>
	</div>
<?php 
}
else
{
?>
	<div class='head'>
	<form action="./<?php echo $_SERVER['PHP_SELF']; ?>">
		<?php echo $paramsPrefixcheck; ?>
		<input type="submit" name="pcheck" value="Search and remove prefix">
	</form>
	</div>
<?php 
}
?>

<form action="./generator_action.php" METHOD="POST">

<div class='head'>Classname</div>
<div class="entry">
	<div class="inp_line"><input class="textinput" type='text' name='clName' value="DB<?php echo htmlentities( ucfirst( getMixedCase( $databaseTable ) ) ); ?>"></div>
</div>
	
<?php 

$currentNumber = 1;

$totalColumns = mysql_num_rows($colListResource);

//$tracer->trace( "total: $totalColumns" );

// Ausgabe aller Spalten und der DB-Class-Einstellungen:
while( $colEntry = mysql_fetch_row( $colListResource ) )
{
	// Zhlen:
	$positionCounter++;
	
	// Spaltenname
	$column   = $colEntry[0];
	$colType  = $colEntry[1];
	
	$colKey   = $colEntry[3];
	
	$colExtra = $colEntry[5];
	
	$columnClassification = classifyColumnType( $colType );
	
	// Primary-Key: ja / nein:
	$isPrimaryKey = strtoupper( $colKey ) == "PRI";
	
	// Auto-Inc: ja / nein:
	$isAutoInc = preg_match( "/auto_increment/", $colExtra ) > 0;
	
	//$tracer->trace( "$colExtra" );
	
	/*
	if( $isAutoInc )
		//$tracer->trace( "Column $column is autoinc" );
	else
		//$tracer->trace( "Column $column is not autoinc" );
	*/
	if( $isPrimaryKey )
		$primaryKey = $column;
	
	
	// Lnge der aktuellen Spalte:
	$columnLength = strlen( $column );
	
	// MixedCase-Variabel vorbelegen.
	$columnMixedCase = $column;
	
	// Wir parsen den Spaltennamen via "getMixedCase". Das Ergebnis beginnt immer
	// mit einem Kleinbuchstaben. Da wir aber "get" der "set" vor den Spaltennamen 
	// setzen, mssen wir den spaltennamen zuvor noch mit einem Grobuchstaben 
	// versehen.
	if( $doPrefixSearch )
	{
		// Falls ein Prefix gefunden wurde, werden alle Spaltennamen um die Lnge
		// des Prefix gekrzt, d.h. die ersten "colPrefixLength" Buchstaben werden
		// vom Spaltennamen entfernt.
		if( $colPrefixLength > 0 )
		{
			
			$columnWithoutPrefix = substr( $column, $colPrefixLength-1, $columnLength - $colPrefixLength +1 );
			if( $columnLength - $colPrefixLength > 2 )
			{
				// Bei mehr als zwei Buchstaben wir nur der erste gro geschrieben:
				$columnMixedCase= ucfirst( getMixedCase( $columnWithoutPrefix ) );
			}
			else
			{
				// Bei zwei Buchstaben schreiben wir alles gro:
				$columnMixedCase= strtoupper( getMixedCase( $columnWithoutPrefix ) );
			}
		} /* end-if( colPrefixLength > 0 ) */
		else 
		{
			// Prefix-Suche ergab kein Prefix.
			if( $columnLength > 2 )
			{
				// Bei mehr als zwei Buchstaben wir nur der erste gro geschrieben:
				$columnMixedCase = ucfirst( getMixedCase( $column ) );
			}
			else
			{
				// Bei zwei Buchstaben schreiben wir alles gro:
				$columnMixedCase = strtoupper( getMixedCase( $column ) );
			}
		} /* end-else( colPrefixLength > 0 ) */
	} /* end-if( doPrefixSearch ) */
	else 
	{
		// Keine Prefix-Suche.
		if( $columnLength > 2 )
		{
			// Bei mehr als zwei Buchstaben wir nur der erste gro geschrieben:
			$columnMixedCase = ucfirst( getMixedCase( $column ) );
		} /* end-if( columnLength > 2 ) */
		else 
		{
			// Bei zwei Buchstaben schreiben wir alles gro:
			$columnMixedCase = strtoupper( getMixedCase( $column ) );
		}
		
	} /* end-else( doPrefixSearch ) */
	
	
	
	
	$t1Chk = $columnClassification == COLUMN_CLASS_BOOLEAN  ? "checked" : "";
	$t2Chk = $columnClassification == COLUMN_CLASS_INTEGER  ? "checked" : "";
	$t3Chk = $columnClassification == COLUMN_CLASS_STRING   ? "checked" : "";
	$t4Chk = $columnClassification == COLUMN_CLASS_DATETIME ? "checked" : "";
	
	$t3Chk = $columnClassification == COLUMN_CLASS_UNKNOWN  ? "checked" : $t3Chk;
	
	// Getter-Prefix fr Bool ist "is", ansosnten "get":
	$getterPrefix = $columnClassification == COLUMN_CLASS_BOOLEAN  ? "is" : "get";
	
	//$tracer->trace( "col: $column type $colType class: $columnClassification" );
	
	
	// $insertChk   = $isPrimaryKey ? "" : "checked";
	$insertChk   = "checked";
	$insertChk   = $isAutoInc ? "" : $insertChk;
	$updateChk   = "checked";
	$nowOnUpdChk = $columnClassification == COLUMN_CLASS_DATETIME ? "checked" : "";
	$nowOnInsChk = $columnClassification == COLUMN_CLASS_DATETIME ? "checked" : "";
	$lateLoadChk = "";
	
	$infoText = $isPrimaryKey ? " (primary key)" : "";
	
	$prevNumber = $currentNumber -1;
	$nextNumber = $currentNumber +1;
	
	$prevLink = "prev";
	if( $prevNumber > 0 )
	{
		$prevLink = "<a href=\"#num$prevNumber\">prev</a>";
	}
	
	$nextLink = "<a name=\"num$currentNumber\">next</a>";
	if( $nextNumber <= $totalColumns )
	{
		$nextLink = "<a name=\"num$currentNumber\" href=\"#num$nextNumber\">next</a>";
	}
	
	
?>
	<div class='nextEntry'><?php echo $prevLink; ?> | <?php echo $nextLink; ?></div>
	<div class='head'><?php echo htmlentities($column); ?><?php echo htmlentities($infoText); ?></div>
	<div class="entry">
	<div>Getter: <input type='hidden' name='columns[]' value="<?php echo htmlentities($column); ?>"></div>
	<div class="inp_line"><input class="textinput" type='text' name='getter[<?php echo htmlentities($column); ?>]' value="<?php echo $getterPrefix; ?><?php echo htmlentities($columnMixedCase); ?>"></div>
	<div>Setter:</div>
	<div class="inp_line"><input class="textinput" type='text' name='setter[<?php echo htmlentities($column); ?>]' value="set<?php echo htmlentities($columnMixedCase); ?>"></div>
	<div class="inp_line">
		treat as: 
		<input type='radio' name='treatment[<?php echo htmlentities($column); ?>]' value="bool"    <?php echo $t1Chk; ?> id="t1_<?php echo $positionCounter; ?>"> <label for="t1_<?php echo $positionCounter; ?>">boolean</label>
		<input type='radio' name='treatment[<?php echo htmlentities($column); ?>]' value="integer" <?php echo $t2Chk; ?> id="t2_<?php echo $positionCounter; ?>"> <label for="t2_<?php echo $positionCounter; ?>">integer</label>
		<input type='radio' name='treatment[<?php echo htmlentities($column); ?>]' value="string"  <?php echo $t3Chk; ?> id="t3_<?php echo $positionCounter; ?>"> <label for="t3_<?php echo $positionCounter; ?>">string</label>
		<input type='radio' name='treatment[<?php echo htmlentities($column); ?>]' value="stamp"   <?php echo $t4Chk; ?> id="t4_<?php echo $positionCounter; ?>"> <label for="t4_<?php echo $positionCounter; ?>">timestamp</label>
	</div>
	<div class="inp_line">
		<div><input type='checkbox' <?php echo $insertChk  ; ?> name='setinsert[<?php echo htmlentities($column); ?>]' value="1"      id="s1_<?php echo $positionCounter; ?>" > <label for="s1_<?php echo $positionCounter; ?>">set on insert</label></div>
		<div><input type='checkbox' <?php echo $updateChk  ; ?> name='setupdate[<?php echo htmlentities($column); ?>]' value="1"      id="s2_<?php echo $positionCounter; ?>" > <label for="s2_<?php echo $positionCounter; ?>">set on update</label></div>
		<div><input type='checkbox' <?php echo $nowOnUpdChk; ?> name='setnowonupdate[<?php echo htmlentities($column); ?>]' value="1" id="s3_<?php echo $positionCounter; ?>" > <label for="s3_<?php echo $positionCounter; ?>">set to &quot;NOW&quot; on update</label></div>
		<div><input type='checkbox' <?php echo $nowOnInsChk; ?> name='setnowoninsert[<?php echo htmlentities($column); ?>]' value="1" id="s5_<?php echo $positionCounter; ?>" > <label for="s5_<?php echo $positionCounter; ?>">set to &quot;NOW&quot; on insert</label></div>
		<!-- <div><input type='checkbox' <?php echo $lateLoadChk; ?> name='lateloading[<?php echo htmlentities($column); ?>]' value="1"    id="s4_<?php echo $positionCounter; ?>" > <label for="s4_<?php echo $positionCounter; ?>">load on demand only</label></div> -->
	</div>
	</div>
	
<?php 
	++$currentNumber;
}
?>
<div id="buttonlist"><input type="submit" name="create" value="Create"></div>
<input type='hidden' name='primary' value="<?php echo htmlentities( $primaryKey ); ?>">
<input type='hidden' name='dbhost' value="<?php echo htmlentities( $databaseHost ); ?>">
<input type='hidden' name='dbuser' value="<?php echo htmlentities( $databaseUser ); ?>">
<input type='hidden' name='dbpass' value="<?php echo htmlentities( $databasePass ); ?>">
<input type='hidden' name='db' value="<?php echo htmlentities( $database ); ?>">
<input type='hidden' name='dbtable' value="<?php echo htmlentities( $databaseTable ); ?>">
</form>
</div>
<div id="navibottom"><div class='navicontent'><a href="./table.php?<?php echo $backParams; ?>">Back</a></div></div>
</body>
</html>
