<?php  

define( "DB_FUNCTIONS_TEMPLATES", 1 );

//if( ! defined("GENERIC_TRACER_CLASS") )
//	include( "./Tracer/generic_tracer.class.php" );
//
//$tracer = new Tracer("/tmp/trace.log");
//$tracer->setTracingActive( true );


/** Getter-Typ fr Booleans */
define( "GETTER_TYPE_BOOLEAN", 1 );

/** Getter-Typ fr Stings */
define( "GETTER_TYPE_STRING", 2 );

/** Getter-Typ fr Integers */
define( "GETTER_TYPE_INTEGER", 3 );

/** Getter-Typ fr Timestamps */
define( "GETTER_TYPE_TIMESTAMP", 4 );

/** Getter-Typ fr Booleans, Lesen erst bei Anfrage */
define( "GETTER_TYPE_DELAYEDREAD_BOOLEAN", 5 );

/** Getter-Typ fr Strings, Lesen erst bei Anfrage */
define( "GETTER_TYPE_DELAYEDREAD_STRING", 6 );

/** Getter-Typ fr Integers, Lesen erst bei Anfrage */
define( "GETTER_TYPE_DELAYEDREAD_INTEGER", 7 );

/** Getter-Typ fr Timestamps, Lesen erst bei Anfrage */
define( "GETTER_TYPE_DELAYEDREAD_TIMESTAMP", 8 );

/** Setter-Typ fr Booleans */
define( "SETTER_TYPE_BOOLEAN", 1 );

/** Setter-Typ fr Strings */
define( "SETTER_TYPE_STRING", 2 );

/** Setter-Typ fr Integers */
define( "SETTER_TYPE_INTEGER", 3 );

/** Setter-Typ fr Timestamps */
define( "SETTER_TYPE_TIMESTAMP", 4 );





/**
Template for getter-function. 
@param string functionName Funktionsname
@param integer getterType Getter-Typ
@return string Function-Body
@author M.Beranek
*/
function getGetter( $functionName, $getterType, $getterValue)
{
	
	//global $tracer; 
	
	// TODO: Templates fr die diversen Getter-Typen erstellen.
	// TODO: Templates fr diverse andere Programmiersprachen erstellen.
	
	// TODO: Delayed-Getter
	
	$fBody_string = "\tfunction $functionName()\n\t{
		return \$this->$getterValue;
	}\n\n\n";
	
	$fBody_bool = "\tfunction $functionName()\n\t{
		return \$this->$getterValue == 1;
	}\n\n\n";
	
	$fBody_integer = "\tfunction $functionName()\n\t{
		return (int)(\$this->$getterValue);
	}\n\n\n";
	
	$fBody_timstamp = "\tfunction $functionName()\n\t{
		return \$this->$getterValue;
	}\n\n\n";
	
	/*
	//$tracer->trace( "body boolean:\n$fBody_bool");
	//$tracer->trace( "body string:\n$fBody_string");
	//$tracer->trace( "body integer:\n$fBody_integer");
	//$tracer->trace( "body timestamp:\n$fBody_timstamp");
	*/
	
	//$tracer->trace( "getter-type: $getterType");
	
	switch( $getterType )
	{
		
		// Fall 1: Boolean
		case GETTER_TYPE_BOOLEAN:
		{
			return $fBody_bool;
		}
		
		// Fall 2: String
		case GETTER_TYPE_STRING:
		{
			return $fBody_string;
		}
		
		// Fall 3: Integer
		case GETTER_TYPE_INTEGER:
		{
			return $fBody_integer;
		}
		
		// Fall 4: Timestamp
		case GETTER_TYPE_TIMESTAMP:
		{
			return $fBody_timstamp;
		}
		
		// Fall 5: Boolean, Delayed
		case GETTER_TYPE_DELAYEDREAD_BOOLEAN:
		{
			return $fBody_bool;
		}
		
		// Fall 6: String, Delayed
		case GETTER_TYPE_DELAYEDREAD_STRING:
		{
			return $fBody_string;
		}
		
		// Fall 7: Integer, Delayed
		case GETTER_TYPE_DELAYEDREAD_INTEGER:
		{
			return $fBody_integer;
		}
		
		// Fall 7: Timestamp, Delayed
		case GETTER_TYPE_DELAYEDREAD_TIMESTAMP:
		{
			return $fBody_timstamp;
		}
	
	}
	
	return "";
}


/**
Template for setter-function. 
@param string functionName Funktionsname
@param integer getterType Getter-Typ
@return string Function-Body
@author M.Beranek
*/
function getSetter( $functionName, $setterType, $setterValue)
{
	//global $tracer; 
	
	// TODO: Templates fr die diversen Setter-Typen erstellen.
	// TODO: Templates fr diverse andere Programmiersprachen erstellen.
	
 	
	$fBody_string = "\tfunction $functionName"."(\$sValue)\n\t{
		\$this->$setterValue = \$sValue;
	}\n\n\n";
	
	$fBody_bool = "\tfunction $functionName(\$bValue)\n\t{
		\$this->$setterValue = \$bValue===true ? 1 : 0;
	}\n\n\n";
	
	$fBody_integer = "\tfunction $functionName(\$iValue)\n\t{
		\$this->$setterValue = (int) \$iValue;
	}\n\n\n";
	
	$fBody_timstamp = "\tfunction $functionName(\$stampValue)\n\t{
		\$this->$setterValue = \$stampValue;
	}\n\n\n";
	
	
	switch( $setterType )
	{
		
		// Fall 1: Boolean
		case SETTER_TYPE_BOOLEAN:
		{
			return $fBody_bool;
		}
		
		// Fall 2: String
		case SETTER_TYPE_STRING:
		{
			return $fBody_string;
		}
		
		// Fall 3: Integer
		case SETTER_TYPE_INTEGER:
		{
			return $fBody_integer;
		}
		
		// Fall 4: Timestamp
		case SETTER_TYPE_TIMESTAMP:
		{
			return $fBody_timstamp;
		}
		
		
	}
	
	return "";
}



/**
Template for getter-doc.
@param integer i Description
@param boolean b Description
@param string s Description
@return integer Description
@author M.Beranek
*/
function getGetterDocTemplate( $colname, $colTreatment )
{
	
	$now = date( "Y-m-d" );
	
	
	switch( $colTreatment )
	{
		
		// Boolean:
		case "bool":
		{
			$returnType = "@return boolean true / false = <code>$colname</code> set / not set";
			break;
		}
	
		// Integer:
		case "integer":
		{
			$returnType = "@return integer field-value for <code>$colname</code>";
			break;
		}
	
		// Strings:
		case "string":
		{
			$returnType = "@return string field-value for <code>$colname</code>";
			break;
		}
	
		// Timestamps:
		case "stamp":
		{
			$returnType = "@return string field-value for <code>$colname</code>";
			break;
		}
	
		// Fallback:
		default:
		{
			break;
		}
	}
	
	
	$docTemplate = "\t// ---------------------------------------------------------------
	/**
	Returns the value for the db-field <code>$colname</code>.
	$returnType
	@author db.class.generator
	@date $now
	*/\n";
	
	return $docTemplate;
	
}


/**
Template for setter-doc.
@param integer i Description
@param boolean b Description
@param string s Description
@return integer Description
@author M.Beranek
*/
function getSetterDocTemplate( $colname, $colTreatment )
{
	
	
	$now = date( "Y-m-d" );
	
	
	switch( $colTreatment )
	{
		
		// Boolean:
		case "bool":
		{
			$paramType = "@param boolean bValue true / false = set <code>$colname</code> / don't set <code>$colname</code>";
			break;
		}
	
		// Integer:
		case "integer":
		{
			$paramType = "@param integer iValue field-value for <code>$colname</code>";
			break;
		}
	
		// Strings:
		case "string":
		{
			$paramType = "@param string sValue field-value for <code>$colname</code>";
			break;
		}
	
		// Timestamps:
		case "stamp":
		{
			$paramType = "@param string stampValue field-value for <code>$colname</code>";
			break;
		}
	
		// Fallback:
		default:
		{
			break;
		}
	}
	
	
	$docTemplate = "\t// ---------------------------------------------------------------
	/**
	Sets the value for the db-field <code>$colname</code>.
	$paramType
	@author db.class.generator
	@date $now
	*/\n";
	
	return $docTemplate;
	
}




/**
Template for loader-doc.
@param integer i Description
@param boolean b Description
@param string s Description
@return integer Description
@author M.Beranek
*/
function getLoaderDocTemplate()
{
	$now = date( "Y-m-d" );
	
	$docTemplate = "\t// ---------------------------------------------------------------
	/**
	Loads a dataset.
	@param integer id dataset-id (primary-key)
	@return boolean true / false = success / error
	@author db.class.generator
	@date $now
	*/\n";
	
	return $docTemplate;
	
}



/**
Template for loader-function.
@param string primary Primary-Key
@param array cols Array mit den Spaltennamen
@param string table Name der Tabelle
@param array treatment Art, wie die Spalten behandelt werden sollen
@return string Funktions-Body
@author M.Beranek
*/
function getLoader( $primary, $cols, $table, $treatment )
{
	
	$loadPrimaryInit = "";
	$loadPrimaryOnError = "";
	$loadWhereClause = "";
	
	// Behandlung des Primary-Key:
	switch( $treatment[ $primary ] )
	{
		case "integer":
		{
			$loadPrimaryInit = "\$this->$primary = (int)\$loadID;";
			$loadPrimaryOnError = "\t\t\t\$this->$primary = 0;\n";
			$loadWhereClause = "$primary = \".(int)\$this->$primary.\"";
			break;
		}
		
		default:{
			$loadPrimaryInit = "\$this->$primary = \$loadID;";
			$loadPrimaryOnError = "\t\t\t\$this->$primary = \"\";\n";
			$loadWhereClause = "$primary = '\".\$this->$primary.\"'";
			break;
		}
	}
	
	
	
	
	// Fehler-Behandlung:
	$dbError   = "if( mysql_errno() > 0 )\n";
	$dbError  .= "\t\t{\n";
	$dbError  .= "\t\t\t\$this->dbErrNo = mysql_errno();\n";
	$dbError  .= "\t\t\t\$this->dbErrMsg = mysql_error();\n";
	$dbError  .= $loadPrimaryOnError;
	$dbError  .= "\t\t\treturn false;\n";
	$dbError  .= "\t\t}\n";
	
	$dbOkay   = "\$this->dbErrNo = 0;\n";
	$dbOkay  .= "\t\t\$this->dbErrMsg = \"\";\n";
	$dbOkay  .= "\t\treturn true;\n\n";
	
	
	// DB-Connects:
	$dbConnect = "mysql_connect( \$this->dbHost, \$this->dbUser, \$this->dbPass );";
	// DB-Selects:
	$dbSelect  = "mysql_select_db( \$this->database );";
	
	// SQL-Statment zum Laden der Daten:
	$loadQuery  = "SELECT\n";
	
	// Spalten-Behandlung:
	$num = 0;
	$resultGetter = "";
	$maximum = getLongestColumnNameCount( $cols );
	
	foreach( $cols as $column)
	{
		// Spacer:
		$spacesCount = $maximum - strlen( $column );
		$spacer = "";
		for( $i=0; $i<$spacesCount; $i++)
		{
			$spacer .= " ";
		}
		
		
		if( $column != $primary )
		{
		
			// SQL-String:
			$loadQuery .= "\t\t\t$column,\n";
			
			// SQL-Result auslesen:
			$colTreatment = $treatment[ "$column" ];
			switch( $colTreatment )
			{
				case "integer":
				{
					$resultGetter .= "\t\t\$this->$column$spacer = (int) \$sqlRow[$num];\n";
					break;
				}
				
				case "bool":
				{
					$resultGetter .= "\t\t\$this->$column$spacer = (int) \$sqlRow[$num];\n";
					break;
				}
				
				default:{
					$resultGetter .= "\t\t\$this->$column$spacer =       \$sqlRow[$num];\n";
					break;
				}
			}
			
			++$num;
		}
	}
	
	// Letztes Komma entfernen:
	$loadQuery  = substr( $loadQuery, 0, strlen($loadQuery)-2 );
	
	// Tablle anhngen:
	$loadQuery .= "\n\t\t\tFROM $table";
	
	// WHERE-Clause anhngen:
	$loadQuery .= "\n\t\t\tWHERE $loadWhereClause";
	
	
	
	// Funktion:
	$fBody = "\tfunction load( \$loadID )
	{
		$loadPrimaryInit
		
		$dbConnect
		$dbError
		$dbSelect
		$dbError
		
		\$sqlQuery = \"$loadQuery\";
		\$sqlResult = mysql_query( \$sqlQuery );
		$dbError
		
		\$sqlRow = mysql_fetch_row( \$sqlResult );
		
$resultGetter
		
		if( mysql_num_rows( \$sqlResult ) != 1 )
		{
			$loadPrimaryOnError
		}
		
		$dbOkay
		
	}\n\n\n";
	
	
	return $fBody;
	
}



/**
Template for update-doc.
@return string Documentation
@author M.Beranek
*/
function getUpdaterDocTemplate()
{
	$now = date( "Y-m-d" );
	
	$docTemplate = "\t// ---------------------------------------------------------------
	/**
	Updates the dataset.
	@return boolean true / false = success / error
	@author db.class.generator
	@date $now
	*/\n";
	
	return $docTemplate;
	
}


/**
Template for update-function.
@param string primary Primary-Key
@param array cols Array mit den Spaltennamen
@param string table Name der Tabelle
@param array treatment Art, wie die Spalten behandelt werden sollen
@return string Funktions-Body
@author M.Beranek
*/
function getUpdater( $primary, $cols, $table, $treatment, $setUpdate, $setUpdateNow )
{
	
	// Behandlung des Primary-Key:
	switch( $treatment[ $primary ] )
	{
		case "integer":
		{
			$updWhereClause = "$primary = \".(int)\$this->$primary.\"";
			break;
		}
		
		default:{
			$updWhereClause = "$primary = '\".\$this->$primary.\"'";
			break;
		}
	}
	
	
	
	
	// Fehler-Behandlung:
	$dbError   = "if( mysql_errno() > 0 )\n";
	$dbError  .= "\t\t{\n";
	$dbError  .= "\t\t\t\$this->dbErrNo = mysql_errno();\n";
	$dbError  .= "\t\t\t\$this->dbErrMsg = mysql_error();\n";
	$dbError  .= "\t\t\treturn false;\n";
	$dbError  .= "\t\t}\n";
	
	$dbOkay   = "\$this->dbErrNo = 0;\n";
	$dbOkay  .= "\t\t\$this->dbErrMsg = \"\";\n";
	$dbOkay  .= "\t\treturn true;\n\n";
	
	
	// DB-Connects:
	$dbConnect = "mysql_connect( \$this->dbHost, \$this->dbUser, \$this->dbPass );";
	// DB-Selects:
	$dbSelect  = "mysql_select_db( \$this->database );";
	
	// SQL-Statment zum Laden der Daten:
	$sqlUpdater  = "UPDATE $table SET\n";
	
	// Spalten-Behandlung:
	$num = 0;
	$maximum = getLongestColumnNameCount( $cols );
	
	foreach( $cols as $column)
	{
		// Spacer:
		$spacesCount = $maximum - strlen( $column );
		$spacer = "";
		for( $i=0; $i<$spacesCount; $i++)
		{
			$spacer .= " ";
		}
		
		
		if( $setUpdate[ $column ] ){
			if( $column != $primary )
			{
			
				// SQL-Update:
				$colTreatment = $treatment[ "$column" ];
				switch( $colTreatment )
				{
					case "integer":
					{
						$sqlUpdater .= "\t\t\t$column$spacer = '\".(int)\$this->$column.\"',\n";
						break;
					}
					
					case "bool":
					{
						$sqlUpdater .= "\t\t\t$column$spacer = '\".(int)\$this->$column.\"',\n";
						break;
					}
					
					case "stamp":
					{
						if( $setUpdateNow[ $column ] )
						{
							$sqlUpdater .= "\t\t\t$column$spacer = NOW(),\n";
						}
						else
						{
							$sqlUpdater .= "\t\t\t$column$spacer = '\".addslashes(\$this->$column).\"',\n";
						}
						break;
					}
					
					default:{
						$sqlUpdater .= "\t\t\t$column$spacer = '\".addslashes(\$this->$column).\"',\n";
						break;
					}
				}
				
				++$num;
			}
		}
	}
	
	// Letztes Komma entfernen:
	$sqlUpdater  = substr( $sqlUpdater, 0, strlen($sqlUpdater)-2 );
	
	// WHERE-Clause anhngen:
	$sqlUpdater .= "\n\t\t\tWHERE $updWhereClause";
	
	
	
	// Funktion:
	$fBody = "\tfunction update()
	{
		$dbConnect
		$dbError
		$dbSelect
		$dbError
		
		\$sqlQuery = \"$sqlUpdater\";
		\$sqlResult = mysql_query( \$sqlQuery );
		$dbError
		$dbOkay
		
	}\n\n\n";
	
	
	return $fBody;
	
}


/**
Template for sync-doc.
@return string Documentation
@author M.Beranek
*/
function getSyncerDocTemplate()
{
	$now = date( "Y-m-d" );
	
	$docTemplate = "\t// ---------------------------------------------------------------
	/**
	Synchronizes the dataset.
	I.e. if the dataset has an id (primary-key-value), call <code>update</code>.
	If the dataset does not have an id, call <code>insert</code> instead.
	@return boolean true / false = success / error
	@author db.class.generator
	@date $now
	*/\n";
	
	return $docTemplate;
	
}


/**
Template for sync-function.
@param integer i Description
@param boolean b Description
@param string s Description
@return integer Description
@author M.Beranek
*/
function getSyncer( $primary, $treatment )
{
	
	// Behandlung des Primary-Key:
	switch( $treatment[ $primary ] )
	{
		case "integer":
		{
			$condition = "\$this->$primary > 0";
			break;
		}
		
		default:{
			$condition = "\$this->$primary != \"\"";
			break;
		}
	}
	
	
	
	
	$fBody  = "\tfunction sync()\n";
	$fBody .= "\t{\n";
	$fBody .= "\t\tif( $condition )\n";
	//$fBody .= "\t\t{\n";
	$fBody .= "\t\t\treturn \$this->update();\n";
	//$fBody .= "\t\t}\n";
	$fBody .= "\t\telse\n";
	//$fBody .= "\t\t{\n";
	$fBody .= "\t\t\treturn \$this->insert();\n";
	//$fBody .= "\t\t}\n";
	$fBody .= "\t}\n\n\n";
	
	return $fBody;
}




/**
Gets the longest column-name.
@param array columnList array of column-names
@return integer maximum length
@author M.Beranek
*/
function getLongestColumnNameCount( $columnList )
{
	$maximum = 0;
	foreach ( $columnList as $col )
	{
		$length = strlen( $col );
		if( $length > $maximum )
		{
			$maximum = $length;
		}
	}
	
	return $maximum;
}




/**
Template for insertion-doc.
@return string Documentation
@author M.Beranek
*/
function getInserterDocTemplate()
{
	$now = date( "Y-m-d" );
	
	$docTemplate = "\t// ---------------------------------------------------------------
	/**
	Inserts a dataset.
	@param integer id dataset-id (primary-key)
	@return boolean true / false = success / error
	@author db.class.generator
	@date $now
	*/\n";
	
	return $docTemplate;
	
}



/**
Template for dataset-insertion.
@param string primary Primary-Key
@param array cols Array mit den Spaltennamen
@param string table Name der Tabelle
@param array treatment Art, wie die Spalten behandelt werden sollen
@return string Funktions-Body
@author M.Beranek
*/
function getInserter( $primary, $cols, $table, $treatment, $setInsert, $setInsertNow )
{
	
	$loadPrimaryOnError = "";
	$loadMysqlID = "";
	$loadMysqlIDFallback = "";
	
	// Behandlung des Primary-Key:
	switch( $treatment[ $primary ] )
	{
		case "integer":
		{
			$loadPrimaryOnError = "\t\t\t\$this->$primary = 0;\n";
			$loadMysqlID = "\$this->$primary = (int) mysql_insert_id(\$myConnection);";
			$loadMysqlIDFallback = "if(\$this->$primary == 0){\n"
				. "\t\t\t\$idQuery = \"SELECT LAST_INSERT_ID() AS iID\";\n"
				. "\t\t\t\$idResult = mysql_query( \$idQuery );\n"
				. "\t\t\t\$this->$primary = (int) mysql_result( \$idResult, 0, \"iID\" );\n"
				. "\t\t}";
			break;
		}
		
		default:{
			$loadPrimaryOnError = "\t\t\t\$this->$primary = \"\";\n";
			$loadMysqlID = "\$this->$primary = mysql_insert_id(\$myConnection);";
			$loadMysqlIDFallback = "if(\$this->$primary == \"\"){\n"
				. "\t\t\t\$idQuery = \"SELECT LAST_INSERT_ID() AS iID\";\n"
				. "\t\t\t\$idResult = mysql_query( \$idQuery );\n"
				. "\t\t\t\$this->$primary = mysql_result( \$idResult, 0, \"iID\" );\n"
				. "\t\t}";
			break;
		}
	}
	
	
	
	
	// Fehler-Behandlung:
	$dbError   = "if( mysql_errno() > 0 )\n";
	$dbError  .= "\t\t{\n";
	$dbError  .= "\t\t\t\$this->dbErrNo = mysql_errno();\n";
	$dbError  .= "\t\t\t\$this->dbErrMsg = mysql_error();\n";
	$dbError  .= $loadPrimaryOnError;
	$dbError  .= "\t\t\treturn false;\n";
	$dbError  .= "\t\t}\n";
	
	$dbOkay   = "\$this->dbErrNo = 0;\n";
	$dbOkay  .= "\t\t\$this->dbErrMsg = \"\";\n";
	$dbOkay  .= "\t\treturn true;\n\n";
	
	
	// DB-Connects:
	$dbConnect = "\$myConnection = mysql_connect( \$this->dbHost, \$this->dbUser, \$this->dbPass );";
	// DB-Selects:
	$dbSelect  = "mysql_select_db( \$this->database );";
	
	// SQL-Statment zum Laden der Daten:
	$insertQuery  = "INSERT INTO $table (\n";
	
	// Spalten-Behandlung:
	$num = 0;
	$resultGetter = "";
	$maximum = getLongestColumnNameCount( $cols );
	
	// SQL-Value abspeichern:
	$valueQuery = "";
			
	foreach( $cols as $column)
	{
		// Spacer:
		$spacesCount = $maximum - strlen( $column );
		$spacer = "";
		for( $i=0; $i<$spacesCount; $i++)
		{
			$spacer .= " ";
		}
		
		
		//if( $column != $primary )
		if( $setInsert[ $column ] )
		{
		
			// SQL-String:
			$insertQuery .= "\t\t\t$column,\n";
			
			
			$colTreatment = $treatment[ "$column" ];
			switch( $colTreatment )
			{
				case "integer":
				{
					$valueQuery .= "\t\t\t'\".     (int) \$this->$column$spacer .\"',\n";
					break;
				}
				
				case "bool":
				{
					$valueQuery .= "\t\t\t'\".     (int) \$this->$column$spacer .\"',\n";
					break;
				}
				
				case "stamp":
				{
					if( $setInsertNow[ $column ])
					{
						$valueQuery .= "\t\t\tNOW(),\n";
					}
					else
					{
						$valueQuery .= "\t\t\t'\".addslashes(\$this->$column$spacer).\"',\n";
					}
					break;
				}
				
				default:{
					$valueQuery .= "\t\t\t'\".addslashes(\$this->$column$spacer).\"',\n";
					break;
				}
			}
			
			++$num;
		}
	}
	
	// Letztes Komma entfernen:
	$insertQuery  = substr( $insertQuery, 0, strlen($insertQuery)-2 );
	$valueQuery   = substr( $valueQuery,  0, strlen($valueQuery) -2 );
	
	// Values anhngen:
	$insertQuery .= "\n\t\t\t) VALUES (\n$valueQuery\n\t\t\t)";
	
	
	
	// Funktion:
	$fBody = "\tfunction insert()
	{
		$dbConnect
		$dbError
		$dbSelect
		$dbError
		
		\$sqlQuery = \"$insertQuery\";
		\$sqlResult = mysql_query( \$sqlQuery );
		
		$loadMysqlID
		$loadMysqlIDFallback
		
		$dbError
		$dbOkay
		
	}\n\n\n";
	
	
	return $fBody;
	
}


/**
Template for constructor.
@param integer i Description
@param boolean b Description
@param string s Description
@return integer Description
@author M.Beranek
*/
function getConstructor( $classname, $dbhost, $dbuser, $dbpass, $database, $dbtable)
{
	$now = date( "Y-m-d" );
	
	$fBody = "
	// ---------------------------------------------------------------
	/**
	Constructor for the class <code>$classname</code>.
	The <code>$classname</code>-object represents a single dataset.
	This dataset belongs to the table <code>$dbtable</code> in the database <code>$database</code>.
	The <code>$classname</code>-object connects to the host <code>$dbhost</code> using
	the default username <code>$dbuser</code>. You can change the database-host and username using the
	<code>setDBHost</code>- and <code>setDBUser</code>-methods.
	@author db.class.generator
	@date $now
	*/
	function $classname()
	{
		\$this->dbHost   = \"$dbhost\";
		\$this->dbUser   = \"$dbuser\";
		\$this->dbPass   = \"$dbpass\";
		\$this->database = \"$database\";
		\$this->initialize();
	}
	
	
	// ---------------------------------------------------------------
	/**
	Sets the databasehost, to which we want to connect.
	@param string dbhost hostname of the database
	*/
	function setDBHost( \$dbhost )
	{
		\$this->dbHost   = \$dbhost;
	}
	
	
	// ---------------------------------------------------------------
	/**
	Sets the username of the database-connection.
	@param string dbuser username
	*/
	function setDBUser( \$dbuser )
	{
		\$this->dbUser   = \$dbuser;
	}
	
	
	// ---------------------------------------------------------------
	/**
	Sets the password of the database-connection.
	@param string dbpass password
	*/
	function setDBPass( \$dbpass )
	{
		\$this->dbPass   = \$dbpass;
	}
	";
	
	return $fBody;
}




/**
Template for initializer.
@param integer i Description
@param boolean b Description
@param string s Description
@return integer Description
@author M.Beranek
*/
function getInitializer( $cols, $treatment )
{
	$now = date( "Y-m-d" );
	$maximum = getLongestColumnNameCount( $cols );
	
	$fBody = "
	// ---------------------------------------------------------------
	/**
	Initializes all class-members of the object to default values.
	@author db.class.generator
	@date $now
	*/
	function initialize()
	{\n";
	
	foreach( $cols as $column)
	{
		// Spacer:
		$spacesCount = $maximum - strlen( $column );
		$spacer = "";
		for( $i=0; $i<$spacesCount; $i++)
		{
			$spacer .= " ";
		}
		
		
		$colTreatment = $treatment[ "$column" ];
		switch( $colTreatment )
		{
			case "integer":
			{
				$fBody .= "\t\t\t\$this->$column$spacer = 0;\n";
				break;
			}
			
			case "bool":
			{
				$fBody .= "\t\t\t\$this->$column$spacer = 0;\n";
				break;
			}
			
			case "stamp":
			{
				$fBody .= "\t\t\t\$this->$column$spacer = \"\";\n";
				break;
			}
			
			default:{
				$fBody .= "\t\t\t\$this->$column$spacer = \"\";\n";
				break;
			}
		}
		
	}
	
	
	$fBody .= "
	}
	";
	
	return $fBody;
	
}




/**
Template for deletion-doc.
@return string Documentation
@author M.Beranek
*/
function getDeleterDocTemplate()
{
	$now = date( "Y-m-d" );
	
	$docTemplate = "\t// ---------------------------------------------------------------
	/**
	Deletes the dataset.
	@return boolean true / false = success / error
	@author db.class.generator
	@date $now
	*/\n";
	
	return $docTemplate;
	
}




/**
Template for dataset-detetion.
@param string primary Primary-Key
@param string table Name der Tabelle
@param array treatment Art, wie die Spalten behandelt werden sollen
@return string Funktions-Body
@author M.Beranek
*/
function getDeleter( $primary, $table, $treatment )
{
	
	// Fehler-Behandlung:
	$dbError   = "if( mysql_errno() > 0 )\n";
	$dbError  .= "\t\t{\n";
	$dbError  .= "\t\t\t\$this->dbErrNo = mysql_errno();\n";
	$dbError  .= "\t\t\t\$this->dbErrMsg = mysql_error();\n";
	$dbError  .= "\t\t\treturn false;\n";
	$dbError  .= "\t\t}\n";
	
	$dbOkay   = "\$this->dbErrNo = 0;\n";
	$dbOkay  .= "\t\t\$this->dbErrMsg = \"\";\n";
	$dbOkay  .= "\t\treturn true;\n\n";
	
	
	// DB-Connects:
	$dbConnect = "mysql_connect( \$this->dbHost, \$this->dbUser, \$this->dbPass );";
	// DB-Selects:
	$dbSelect  = "mysql_select_db( \$this->database );";
	
	// Empty primary-key:
	$reInitPrimary = '';
	
	// Behandlung des Primary-Key:
	switch( $treatment[ $primary ] )
	{
		case "integer":
		{
			$updWhereClause = "$primary = \".(int)\$this->$primary.\"";
			$reInitPrimary = "\$this->$primary = 0;";
			break;
		}
		
		default:{
			$updWhereClause = "$primary = '\".\$this->$primary.\"'";
			$reInitPrimary = "\$this->$primary = '';";
			break;
		}
	}
	
	
	
	// SQL-Statment zum Laden der Daten:
	$sqlDeleter  = "DELETE FROM $table WHERE $updWhereClause";
	
	// Funktion:
	$fBody = "\tfunction delete()
	{
		$dbConnect
		$dbError
		$dbSelect
		$dbError
		
		\$sqlQuery = \"$sqlDeleter\";
		\$sqlResult = mysql_query( \$sqlQuery );
		
		$dbError
		
		$reInitPrimary
		
		$dbOkay
		
	}\n\n\n";
	
	
	return $fBody;
	
}



?>
